#!/usr/bin/env python2
#*******************************************************************************
# Licensed Materials - Property of IBM
# 5725-Y38
# @ Copyright IBM Corp. 2018 All Rights Reserved
# US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#*******************************************************************************
import os.path
import sys
from os import environ


def main():

   cmd = ""

   if "DLI_SHARED_FS" in os.environ:
      print(environ.get('DLI_SHARED_FS'))
      cmd = environ.get('DLI_SHARED_FS') + "/tools/spark_tf_launcher/launcher.py"
   else:
      print("Error: environment variable DLI_SHARED_FS must be defined")
      sys.exit()

   if "APP_NAME" in os.environ:
      cmd = cmd + " --sparkAppName=" + environ.get('APP_NAME')
   else:
      print("Error: environment variable APP_NAME must be defined")
      sys.exit()

   if "MODEL" in os.environ:
      pass
   else:
      print("Error: environment variable MODEL must be defined")
      sys.exit()

   if "REDIS_HOST" in os.environ:
      cmd = cmd + " --redis_host=" + environ.get('REDIS_HOST')
   else:
      print("Error: environment variable REDIS_HOST must be defined")
      sys.exit()

   if "REDIS_PORT" in os.environ:
      cmd = cmd + " --redis_port=" + environ.get('REDIS_PORT')
   else:
      print("Error: environment variable REDIS_PORT must be defined")
      sys.exit()

   if not "NUM_WORKERS" in os.environ:
      print("Error: environment variable NUM_WORKERS must be defined")
      sys.exit()
   else:
      numWorkers = int(environ.get('NUM_WORKERS'))
      cmd = cmd + " --worker=" + str(numWorkers)

   if not "NUM_PS" in os.environ:
      print("Error: environment variable NUM_PS must be defined")
      sys.exit()
   else:
      numPs = int(environ.get('NUM_PS'))
      cmd = cmd + " --ps=" + str(numPs)

   if "GPU_PER_WORKER" in os.environ:
      cmd = cmd + " --devices=" + environ.get('GPU_PER_WORKER')
   else:
      print("Error: environment variable GPU_PER_WORKER must be defined")
      sys.exit()

   cmd = cmd + " --work_dir=" + os.path.dirname(environ.get('MODEL'))
   cmd = cmd + " --app_type=executable"
   cmd = cmd + " --model=" + environ.get('DLI_SHARED_FS') + "/tools/dl_plugins/snapml_wrapper.sh --"

   # adding user args
   for i in range(1, len(sys.argv)):
      cmd += " " + sys.argv[i]
      if sys.argv[i] == "python":
         cmd = cmd + " " + environ.get('MODEL')

   # Expected result in json
   print('{"CMD" : "%s"}' % cmd)


if __name__ == "__main__":
   sys.exit(main())

