# KMeans Example using RAPIDS cuML in pai4sk

This is a sample code to show how kmeans from cuML in pai4sk can be used.
The sample code performs kmeans clustering through cuML in pai4sk and through
scikit-learn and compares the results.

# How to run the example
If pandas and scikit-learn are not already installed in the python 3.6 conda
environment, run `conda install pandas scikit-learn`. Then run the
example as below and all GPUs will be used.

```
python example-kmeans.py --nrows 5000 --ncols 10 --nclusters 2
```

The above command first generates random dataset with 2 clusters containing 5000 samples
and 10 features. Then performs KMeans clustering through cuML in pai4sk and through
scikit-learn and compares the results.

See $CONDA_PREFIX/pai4sk/local-examples/cuml-examples/README.md for
description of command line options of the cuML examples.

&copy; Copyright IBM Corporation 2019
