# *****************************************************************
#
# Licensed Materials - Property of IBM 
#
# (C) Copyright IBM Corp. 2019. All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
# ******************************************************************

from __future__ import print_function
from pai4sk.simsearch import embeddings
import argparse

defaultPath = "."
CLI=argparse.ArgumentParser()
CLI.add_argument(
    "--data_path",
    type=str,
    default=defaultPath
)
args = CLI.parse_args()

# This function processes the Google word2vec embeddings in .bin format from the /data/Embeddings directory location and dumps 2 files - `vectors.npz` and `vocabulary.txt` in the same location where the examples are placed.

# LOAD EMBEDDINGS
embeddings.load_word2vec_embeddings(args.data_path + '/data/Embeddings/GoogleNews-vectors-negative300.bin', 'vectors', 'vocabulary.txt')
