# WMD examples

In this example, we will evaluate `Word Movers Distance` for MNIST dataset and evaluate the top-k accuracy.

The SimSearch library offers CPU and GPU implementations of a low-complexity and high-quality approximation of Earth/Word Mover's Distance.

The details of the approximation algorithm are outlined in "http://export.arxiv.org/abs/1812.02091".

# MNIST examples

This test will compare 10000 MNIST test images with 60000 MNIST train images. For each image in the database, the top-33 nearest neighbors will be computed and averaged precision results will be printed.

## Download Data

Download train-images-idx3-ubyte.gz, train-labels-idx1-ubyte.gz, t10k-images-idx3-ubyte.gz and t10k-labels-idx1-ubyte.gz from http://yann.lecun.com/exdb/mnist/, uncompress and move into data/MNIST directory.

## Run examples

If the user wants to run the example on a single node:
One can run the entire example by executing `python $CONDA_PREFIX/pai4sk/simsearch-examples/wmd/example-mnist/example-mnist.py`

If the user wants to run the example by distributing the data across multiple nodes:
One can run the entire example by executing `snaprun python $CONDA_PREFIX/pai4sk/simsearch-examples/wmd/example-mnist/example-mnist.py`

Note:
The datasets should be present in all the machines in the same directory path location for running the examples in distributed (MPI) mode successfully.
